# -*- coding: utf-8 -*-
#
# ApplicationIntegrationServer - Simple Example Plugin
#
# Copyright (c) 2017 MailStore Software GmbH
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.


class Plugin:
    def __init__(self):
        self.plugin_user = "admin"
        self.plugin_password = "Passw0rd"
        self.users = [{"userName": "johnny.jackson", "fullName": "Johnny Jackson", "emailAddresses": ["johnny.jackson@example.com", "johnny.jackson@example.net"], "password":"test-john"},
                      {"userName": "jane.jackson", "fullName": "Jane Jackson", "emailAddresses": ["jane.jackson@example.com", "jane.jackson@example.net"], "password":"test-jane"},
                      {"userName": "jack.jackson", "fullName": "Jack Jackson", "emailAddresses": ["jack.jackson@example.com"], "password":"test-jack"}]

    def list_(self, _):
        return [{k: v for k, v in user.items() if k != "password"} for user in self.users]

    def auth(self, username, password):
        for user in self.users:
            if username == user["userName"] and password == user["password"]:
                return {"succeeded": True}
        return {"succeeded": False}

    def http_authentication(self, username, password):
        return username == self.plugin_user and password == self.plugin_password
